<?php
//$Id: views_datasource.views.inc,v 1.1.2.1 2008/07/07 19:55:39 allisterbeharry Exp $
/**
 * @file views_datasource.views.inc 
 * Views style plugins to render nodes in the XML data format.
 * @see views-view-xml.tpl.php
 * @ingroup views_plugins
 */

/**
 * Implementation of hook_views_plugin
 *
 */
function views_datasource_views_plugins() {
  return array(
    'row' => array( //declare the unformatted row plugin
      'unformatted' => array(
        'title' => t('Unformatted'),
        'help' => t('(Displays the unformatted data for each row from the views query with each row on a new line. Set as | for views_json.'),
        'handler' => 'unformatted_plugin_row',
        'theme' => 'views_view_row_unformatted',
        'uses fields' => TRUE,
        'uses options' => TRUE,
        'type' => 'normal',
      )
     ) 
  );
}

/**
 * Theme preprocess function for views-view-row-unformatted.tpl.php
 */
function template_preprocess_views_view_row_unformatted(&$vars) {
  $view = $vars['view'];
  //print('preprocess');
  // Loop through the fields for this view.
  foreach ($view->field as $id => $field) {
    if (!empty($field->handler) && is_object($field->handler)) {
      $object = new stdClass();
      $object->content = $field['handler']->theme($vars['row']);
      if (isset($field['handler']->field_alias) && isset($vars['row']->{$field['handler']->field_alias})) {
        $object->raw = $vars['row']->{$field['handler']->field_alias};
      }
      else {
        $object->raw = NULL; // make sure it exists to reduce NOTICE
      }
      if (!empty($vars['options']['separator']) && $object->content) {
        $object->separator = filter_xss($vars['options']['separator']);
      }

      $object->handler = $field['handler'];
      $object->class = views_css_safe($id);
      $object->label = check_plain($field['handler']->label());
      $vars['fields'][$id] = $object;
    }
  }
  
} 